#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<malloc.h>
#include<ctype.h>

struct node
{
	int N; /* which sequence */
	int No; /* which residue */
	char a; /* which amino acid */
	struct node* next;
};

struct SEQ_P
{
	char* I;
	char* J;
};

struct TREE
{
	int i;
	struct TREE* next;
};

struct Edge
{
	float alignscore;
	int index1;
	int index2;
};

void findin(struct node* a, int* i,int* n);
void find_place(struct node* connect,struct node*** connect_f, struct node*** connect_final,int** where_in_final);
void Tran_tree(struct TREE** tran_tree,int N);
void toup(char* seq);
int isletter(char c);
int edge_compare (const void *vertex, const void *vertex2);
void makeset(int v,int dad[],int rank[]);
void Union(int v1, int v2, int dad[], int rank[]);
int find(int v, int dad[]);
void  max_span(struct Edge* edge[],int n,struct Edge tree[]); 
int find1(char *seq, int p)      
{
	int n=-1;
	int i;
	for(i=0;i<=p;i++)
	{
		if(*(seq+i)!='-')
			n++;
	}
	return n;
}

int find2(char *seq,int n)    
{
	int i=-1;
        int p;
	for(p=0;;p++)
	{
		if(*(seq+p)!='-')
			i++;
		if(i==n)
			break;
	}
	return p;
}

int main(int argc, char* argv[])
{
	if(argc<2)
        {
          printf("NO input\n");
          exit(1);
        }
	else if(argc>2)
        {
           printf("too many parameters\n");
           exit(1);
        }

	int i,j;	   
	char* filename;
	int l_fname;
	l_fname=strlen(argv[1]);
	filename=(char*)malloc(l_fname*sizeof(char));
	sprintf(filename,"%s",argv[1]);

	char disname[20];
	char pairname[20];
	char* resultname;
	resultname=(char*)malloc((l_fname+4)*sizeof(char));
	sprintf(resultname,"%s.aln",argv[1]);
	sprintf(pairname,"pairwise.pw");
	sprintf(disname,"distance.dis");

	FILE*  pfile; /* open filename */
	FILE* ppw;  /* open pairname */
	FILE* pdis; /* open disname */

	pfile=fopen(filename,"r");
	if(pfile==(FILE*)NULL)
	{
		printf("%s can't be opened.\n",filename);
		exit(1);
	}

/*printf("reading %s..\n",filename);*/
/******below: get the data from filename in FASTA format****/
	int N;
	int max_len_name;
	int max_len_seq;
	char** name;
	char** sequence;
/*(1)find N, max_len_name and max_len_seq*/
	N=0;
	max_len_name=0;
	max_len_seq=0;
	char nm;
	char name_temp[100];
	int len_temp=0;
	while(!feof(pfile))
	{
		fscanf(pfile,"%c",&nm);
		//printf("%c",nm);
		if(feof(pfile))
        		break;
		if(nm=='>')
		{
			N++;
			fscanf(pfile,"%s",&name_temp);
			//printf("name=%s\n",name_temp);
			if(max_len_name<strlen(name_temp))
				max_len_name=strlen(name_temp);
			if(max_len_seq<len_temp)
				max_len_seq=len_temp;
			len_temp=0;
			//printf("\n\n");
		}
		else if(isletter(nm)&&nm!=' '&&nm!='\n')
		{
			//printf("%c",nm);
			len_temp++;
			//printf("%d",len_temp);
		}
	}
	if(max_len_seq<len_temp)
		max_len_seq=len_temp;
	if(N==0)
	{
		printf("this is not FASTA format!!!\n");
		exit(1);
	}
	if(N==1)
	{
		printf("there is only one sequence!\n");
		exit(1);
	}
	max_len_name=max_len_name+1;
	max_len_seq=max_len_seq+1;
	fclose(pfile);
/* end of (1) */

/* (2) allocate memory to name[][] and sequence[][] */
	name=(char**)malloc(N*sizeof(char*));
	for(i=0;i<N;i++)
		name[i]=(char*)malloc(max_len_name*sizeof(char));
	sequence=(char**)malloc(N*sizeof(char*));
	for(i=0;i<N;i++)
		sequence[i]=(char*)malloc(max_len_seq*sizeof(char));
/* end of (2) */    
   
/* (3)read the name[][] and sequence[][] */
	i=-1;
	len_temp=0;
	pfile=fopen(filename,"r");
	while(!feof(pfile)) 
	{ 
		fscanf(pfile,"%c",&nm);
		//printf("%c",nm);
		if(feof(pfile))
			break;
		if(nm=='>') 
		{ 
			i++;
			fscanf(pfile,"%s",name[i]);
			len_temp=0; 
			//printf("\n\n");
		} 
		else if(isletter(nm)&&nm!=' '&&nm!='\n')
		{
			//printf("%c",nm);
			sequence[i][len_temp]=toupper(nm);
			sequence[i][len_temp+1]='\0';
			len_temp++;
		}
	} 
/***** end of (3) ****/
/*for(i=0;i<N;i++)
    printf("%s\n\n",sequence[i]);*/
/******above: get the data from filename in  FASTA format****/



/****** run probcons *****/
/*	printf("running Probcons...\n");*/
	char command[200];  
        sprintf(command,"probcons_modified -ir 0 -pairs %s",filename);
        system(command);
/*	system("rm *.mx2");*/
/******/

/*****below: get the data from pairwise.pw *****/
	struct SEQ_P** seq_pair;
	seq_pair=(struct SEQ_P**)malloc(N*sizeof(struct SEQ_P*));
	for(i=0;i<N;i++)
		seq_pair[i]=(struct SEQ_P*)malloc(N*sizeof(struct SEQ_P));
	for(i=0;i<N;i++)
		for(j=0;j<N;j++)
		{
			seq_pair[i][j].I=(char*)malloc(2*max_len_seq*sizeof(char));
			seq_pair[i][j].J=(char*)malloc(2*max_len_seq*sizeof(char));
		}
	
	ppw=fopen(pairname,"r"); 
        if(ppw==(FILE*)NULL)
        { 
                printf("pairwise.pw can't be opened.\n");
                exit(1); 
        } 	
	for(i=0;i<N;i++)
	{
		for(j=i+1;j<N;j++)
		{
			fscanf(ppw,"%s",name_temp);
    			fscanf(ppw,"%s",seq_pair[i][j].I);
			toup(seq_pair[i][j].I);
			fscanf(ppw,"%s",name_temp);
			fscanf(ppw,"%s",seq_pair[i][j].J);
			toup(seq_pair[i][j].J);
			strcpy(seq_pair[j][i].I,seq_pair[i][j].J);
			strcpy(seq_pair[j][i].J,seq_pair[i][j].I);
			//printf("%s\n",seq_pair[i][j].I);
			//printf("%s\n",seq_pair[i][j].J);
		}
	}
	fclose(ppw);
	system("rm *.pw");
/*****above: get the data from pairwise.pw*****/

/****** below:get alignscore from distance.dis *****/
	float** alignscore;
	alignscore=(float**)malloc(N*sizeof(float*));
	for(i=0;i<N;i++)
		alignscore[i]=(float*)malloc(N*sizeof(float));
  
	pdis=fopen(disname,"r");
        if(pdis==(FILE*)NULL)
        {        
                printf("disname can't be opened.\n");
                exit(1);
        } 
	for(i=0;i<N-1;i++)
	{
		for(j=i+1;j<N;j++)
		{
			fscanf(pdis,"%s %s %f",name_temp,name_temp,&alignscore[i][j]);
		      	alignscore[i][j]=alignscore[i][j]/strlen(seq_pair[i][j].I);
			alignscore[j][i]=alignscore[i][j];
			//printf("%f\n",alignscore[i][j]);
		}
	}
	system("rm *.dis");
/*****above: get alignscore from disname ****/

/******below: construct the tree *****/
	struct Edge** edge;
	edge=(struct Edge**)malloc(N*(N-1)/2*sizeof(struct Edge*));
	for(i=0;i<N*(N-1)/2;i++)
		edge[i]=(struct Edge*)malloc(sizeof(struct Edge));
	int p=0;
	for(i=0;i<N;i++)
	{
		for(j=i+1;j<N;j++)
		{
			edge[p]->alignscore=alignscore[i][j];
			edge[p]->index1=i;
			edge[p]->index2=j;
			p++;
		}
	}	

/*	for(p=0;p<N*(N-1)/2;p++)
		printf("(%d,%d,%f)",edge[p]->index1,edge[p]->index2,edge[p]->alignscore);
	printf("\n\n");*/
	
	qsort (edge, N*(N-1)/2, sizeof(struct Edge*), edge_compare);

/*	for(p=0;p<N*(N-1)/2;p++)
		printf("(%d,%d,%f)",edge[p]->index1,edge[p]->index2,edge[p]->alignscore);
	printf("\n\n");*/

	struct Edge* Tree;
	Tree=(struct Edge*)malloc((N-1)*sizeof(struct Edge));
	max_span(edge,N,Tree);
	
/*	printf("\nTree:");
	for(i=0;i<N-1;i++)
	{
		printf("(%d,%d),",Tree[i].index1,Tree[i].index2);
	}
	printf("\n");*/
/****/
	struct TREE** tree;
	tree=(struct TREE**)malloc(N*sizeof(struct TREE*));
	for(i=0;i<N;i++)
		tree[i]=NULL;

	struct TREE* ps_tree;
	for(p=0;p<N-1;p++)
	{
		i=Tree[p].index1;
		j=Tree[p].index2;
		ps_tree=(struct TREE*)malloc(sizeof(struct TREE));
		ps_tree->i=j;
		ps_tree->next=NULL;
		if(tree[i]==NULL)
			tree[i]=ps_tree;
		else
		{
			ps_tree->next=tree[i];
			tree[i]=ps_tree;
		}

		ps_tree=(struct TREE*)malloc(sizeof(struct TREE));
                ps_tree->i=i; 
                ps_tree->next=NULL;
                if(tree[j]==NULL)
                        tree[j]=ps_tree;
                else 
                {   
                        ps_tree->next=tree[j];
                        tree[j]=ps_tree; 
                } 
	}


/*	for(i=0;i<N;i++)
	{
		if(tree[i]==NULL)
			continue;
                printf("%d:\n",i);
		struct TREE* pEnd_tree;
		pEnd_tree=tree[i];
		while(pEnd_tree!=NULL)
		{
                        printf("%d,",pEnd_tree->i);
			pEnd_tree=pEnd_tree->next;
		}
		printf("\n\n");
	}*/
/******* above:construct the tree *****/

/********** graph **********/

	struct node*** pointer;
    pointer=(struct node***)malloc(N*sizeof(struct node**));
    for(i=0;i<N;i++)
		pointer[i]=(struct node**)malloc(max_len_seq*sizeof(struct node*));
	struct node* ps;
	struct node* pEnd; 	
	for(i=0;i<N;i++)
	{
		int n;
		for(n=0;n<max_len_seq;n++)
		{
			if(sequence[i][n]=='\0')
				break;
			ps=(struct node*)malloc(sizeof(struct node));
			ps->N=i;
			ps->No=n;
			ps->a=sequence[i][n];
			ps->next=NULL;
			pointer[i][n]=ps;
			pEnd=ps; 
			
			struct TREE* pEnd_tree;
			pEnd_tree=tree[i];
			while(pEnd_tree!=NULL)
			{
				j=pEnd_tree->i;
				int pi=find2(seq_pair[i][j].I,n);
                                int pj;
				for(pj=pi-0; pj<=pi+0;pj++)
				{
					if(pj<0)
						continue;
					if(*(seq_pair[i][j].J+pj)=='\0')
						break;
					if(*(seq_pair[i][j].J+pj)!='-')
					{
						int nj=find1(seq_pair[i][j].J,pj);
						ps=(struct node*)malloc(sizeof(struct node));
						ps->N=j;
						ps->No=nj;
						ps->a=sequence[j][nj];
						ps->next=NULL;
						pEnd->next=ps;
						pEnd=ps;
					}
				}
				pEnd_tree=pEnd_tree->next;
			}
		}
	}

//print

/*	for(i=0;i<N;i++)
	{
                int n;
		for(n=0;n<max_len_seq;n++)
		{
			if(sequence[i][n]=='\0')
		        	break;  
			pEnd=pointer[i][n];
			while(1)
			{
				if(pEnd==NULL)
					break;
                                printf("(%d,%d,%c)",pEnd->N,pEnd->No,pEnd->a);
				pEnd=pEnd->next;
			}
                        printf("\n\n");
		}
	}*/
/******** end of graph ********/


/********* connected components *********/
	int n;
	struct node*** connect;
	struct node* pEnd_connect;
	struct node* ps_connect;
	struct node* pEnd_pointer;
	connect=(struct node***)malloc(N*sizeof(struct node**));
	for(i=0;i<N;i++)
		connect[i]=(struct node**)malloc(max_len_seq*sizeof(struct node*));
	for(i=0;i<N;i++)
		for(n=0;n<max_len_seq;n++)
			connect[i][n]=NULL;
	for(i=0;i<N;i++)
	{
		for(n=0;n<max_len_seq;n++)
		{
			if(sequence[i][n]=='\0')
				break;
			if(connect[i][n]!=NULL)
				continue;
			ps=(struct node*)malloc(sizeof(struct node));
			ps->N=i;
			ps->No=n;
			ps->a=sequence[i][n];
			ps->next=NULL;
			connect[i][n]=ps;
			pEnd=ps;
			pEnd_connect=ps;

			while(1)
			{
				if(pEnd_connect==NULL)
					break;
				pEnd_pointer=pointer[pEnd_connect->N][pEnd_connect->No];
				while(1)
				{
					if(pEnd_pointer==NULL)
						break;
					ps_connect=connect[i][n];
					while(1)
					{
						if(ps_connect==NULL)
							break;
						if((ps_connect->N==pEnd_pointer->N)&&(ps_connect->No==pEnd_pointer->No))
							break;
						ps_connect=ps_connect->next;
					}
					if(ps_connect==NULL)
					{
						ps=(struct node*)malloc(sizeof(struct node));
						ps->N=pEnd_pointer->N;
						ps->No=pEnd_pointer->No;
						ps->a=pEnd_pointer->a;
						ps->next=NULL;
						pEnd->next=ps;
						pEnd=ps;

						ps=(struct node*)malloc(sizeof(struct node));
						ps->N=8888;
						ps->No=8888;
						ps->a='n';
						ps->next=NULL;
						connect[pEnd_pointer->N][pEnd_pointer->No]=ps;
					}
					pEnd_pointer=pEnd_pointer->next;
				}
				pEnd_connect=pEnd_connect->next;
			}
		}
	}
	
	struct node*** connect_f;
	connect_f=(struct node***)malloc(N*sizeof(struct node**));
	for(i=0;i<N;i++)
		connect_f[i]=(struct node**)malloc(max_len_seq*sizeof(struct node*));
	for(i=0;i<N;i++)
		for(n=0;n<max_len_seq;n++)
			connect_f[i][n]=NULL;
	for(i=0;i<N;i++)
	{
		for(n=0;n<max_len_seq;n++)
		{
			if(sequence[i][n]=='\0')
				break;
			if(connect[i][n]->N==8888)
				continue;
			int a,b;
			findin(connect[i][n],&a,&b);
			connect_f[a][b]=connect[i][n];
		}
	}
	//print
/*	 for(i=0;i<N;i++)
        { 
                for(n=0;n<max_len_seq;n++)
                { 
                        if(sequence[i][n]=='\0')
                                break;
			if(connect_f[i][n]==NULL)
                                continue;
                        pEnd=connect_f[i][n];
                        while(1) 
                        { 
                                if(pEnd==NULL) 
                                        break;
                                printf("(%d,%d,%c)",pEnd->N,pEnd->No,pEnd->a);
                                pEnd=pEnd->next;
                        } 
                        printf("\n\n");          
                } 
        }*/
/******* end of connected components *****/

/****** generate connect_final *****/
	struct node*** connect_final;
	connect_final=(struct node***)malloc(N*sizeof(struct node**));
    for(i=0;i<N;i++) 
		connect_final[i]=(struct node**)malloc(max_len_seq*sizeof(struct node*));
    for(i=0;i<N;i++)  
		for(n=0;n<max_len_seq;n++)  
			connect_final[i][n]=NULL;	
	for(i=0;i<N;i++)
	{
		for(n=0;n<max_len_seq;n++)
		{
			if(sequence[i][n]=='\0')
				break;
			if(connect_f[i][n]==NULL)
				continue;
			pEnd=connect_f[i][n];
			while(pEnd!=NULL)
			{
				connect_final[pEnd->N][pEnd->No]=connect_f[i][n];
				pEnd=pEnd->next;
			}
		}
	}

/*	for(i=0;i<N;i++)
	{
		for(n=0;n<max_len_seq;n++)
		{
			if(sequence[i][n]=='\0')
				break;
			if(connect_final[i][n]==NULL)
                                printf("%d,%d\n",i,n);
		}
	}*/
/****** end ******/
	
/******** below: arrange the components in alignment ******/ 
	int** where_in_final;
	where_in_final=(int**)malloc(N*sizeof(int*));
	for(i=0;i<N;i++)
		where_in_final[i]=(int*)malloc(max_len_seq*sizeof(int));
	for(i=0;i<N;i++)
		for(n=0;n<max_len_seq;n++)
			where_in_final[i][n]=-88888;

	for(i=0;i<N;i++)
		for(n=0;n<max_len_seq;n++)
		{
			if(*(sequence[i]+n)=='\0')
				break;
			if(connect_f[i][n]==NULL)
				continue;
			if(where_in_final[i][n]==-88888)
				find_place(connect_f[i][n],connect_f,connect_final,where_in_final);
		}

	/*	for(i=0;i<N;i++)
			for(n=0;n<max_len_seq;n++)
			{
				if(where_in_final[i][n]==-88888)
					continue;
                                printf("%d,%d: %d\n",i,n,where_in_final[i][n]);
			}*/


		int maxlength=-1;

		for(i=0;i<N;i++)
			for(n=0;n<max_len_seq;n++)
			{
				if(maxlength<where_in_final[i][n])
					maxlength=where_in_final[i][n];
			}
                maxlength=maxlength+2;
               /* printf("maxlength=%d\n",maxlength);*/
		
		char** sequence_final;
		sequence_final=(char**)malloc(N*sizeof(char*));
		for(i=0;i<N;i++)
			sequence_final[i]=(char*)malloc(maxlength*sizeof(char));	
		for(i=0;i<N;i++)
			for(n=0;n<maxlength-1;n++)
			{
				sequence_final[i][n]='-';
			}

		for(i=0;i<N;i++)
		{
			sequence_final[i][maxlength-1]='\0';
		}

		for(p=0;p<maxlength-1;p++)
		{
			for(i=0;i<N;i++)
			{
				for(n=0;n<max_len_seq;n++)
				{
					if(where_in_final[i][n]==-88888)
						continue;
					if(where_in_final[i][n]==p)
					{
						struct node* pEnd_con;
						pEnd_con=connect_f[i][n];
						while(pEnd_con!=NULL)
						{
							sequence_final[pEnd_con->N][p]=pEnd_con->a;
							pEnd_con=pEnd_con->next;
						}
					}


				}
			}

		}
/******* above: arrange components in alignment ******/

/****** print the result *****/
/*	printf("%s:\n",resultname);*/
	FILE* WRITE;
	WRITE=fopen(resultname,"w");
	for(i=0;i<N;i++)
	{
		fprintf(WRITE,">%s\n%s\n",name[i],sequence_final[i]);
/*		printf(">%s\n%s\n",name[i],sequence_final[i]);*/
	}
/*	printf("done.\n");*/
}

void findin(struct node* a, int* i, int* n)
{
	*i=100000;
	*n=100000;
	struct node* pEnd_a;
	pEnd_a=a;
	while(pEnd_a!=NULL)
	{
		if(pEnd_a->N<*i)
		{
			*i=pEnd_a->N;
			*n=pEnd_a->No;
		}
		else if(pEnd_a->N==*i&&pEnd_a->No<*n)
			*n=pEnd_a->No;
		pEnd_a=pEnd_a->next;
	}
}

void find_place(struct node* connect,struct node*** connect_f, struct node*** connect_final,int** where_in_final)
{
	int maxplace=-1;
	int place;
	struct node* pEnd_con;
	pEnd_con=connect;

	while(pEnd_con!=NULL)
	{
		if(pEnd_con->No==0)
			place=0;
		else
		{
			int a,b;
			findin(connect_final[pEnd_con->N][pEnd_con->No-1],&a,&b);
			if(where_in_final[a][b]==-88888)
				find_place(connect_f[a][b],connect_f,connect_final,where_in_final);
			place=where_in_final[a][b]+1;
		}

		if(maxplace<place)
			maxplace=place;

		pEnd_con=pEnd_con->next;
	}

	int a,b;
	findin(connect,&a,&b);
	where_in_final[a][b]=maxplace;
	
}

void Tran_tree(struct TREE** tran_tree, int N)
{
	int judge=0;
	struct TREE* pSearch1_tree;
	struct TREE* pSearch2_tree;
	struct TREE* pSearch_tree;
	struct TREE* ps_tree;
	struct TREE* pEnd_tree;

	int i=0;

	for(i=0;i<N;i++)
	{
		if(tran_tree[i]==NULL)
			continue;
		pSearch1_tree=tran_tree[i];
		while(pSearch1_tree!=NULL)
		{
			pSearch2_tree=tran_tree[i];
			while(pSearch2_tree!=NULL)
			{
				if(pSearch2_tree==pSearch1_tree)
				{
					pSearch2_tree=pSearch2_tree->next;
					continue;
				}
				pSearch_tree=tran_tree[pSearch1_tree->i];
				while(pSearch_tree!=NULL)
				{
					if(pSearch_tree->i==pSearch2_tree->i)
						break;
					pSearch_tree=pSearch_tree->next;
				}
				
				if(pSearch_tree==NULL)
				{
					if(tran_tree[pSearch1_tree->i]==NULL)
					{
						ps_tree=(struct TREE*)malloc(sizeof(struct TREE));
						ps_tree->i=pSearch2_tree->i;
						ps_tree->next=NULL;
						tran_tree[pSearch1_tree->i]=ps_tree;
						judge=1;
					}
					else
					{
						pEnd_tree=tran_tree[pSearch1_tree->i];
						while(1)
						{
							if(pEnd_tree->next==NULL)
								break;
							pEnd_tree=pEnd_tree->next;
						}
						ps_tree=(struct TREE*)malloc(sizeof(struct TREE));
						ps_tree->i=pSearch2_tree->i;
						ps_tree->next=NULL;
						pEnd_tree->next=ps_tree;
						judge=1;
					}
				}

				pSearch2_tree=pSearch2_tree->next;
			}
			pSearch1_tree=pSearch1_tree->next;
		}
	}

	if(judge==1)
		Tran_tree(tran_tree,N);
}

void toup(char* seq)
{
	int i;
	for(i=0;;i++)
	{
		if(*(seq+i)=='\0')
			break;
		else if(*(seq+i)!='-')
			*(seq+i)=toupper(*(seq+i));
	}
}

int isletter(char c)
{
 
        
if(c=='A'||c=='a'||c=='B'||c=='b'||c=='C'||c=='c'||c=='D'||c=='d'||c=='E'||c=='e'||c=='F'||c=='f'||c=='G'||c=='g'||c=='H'||c=='h'||c=='I'||c=='i'||c=='J'||c=='j'||c=='K'||c=='k'||c=='L'||c=='l'||c=='M'||c=='m'||c=='N'||c=='n'||c=='O'||c=='o'||c=='P'||c=='p'||c=='Q'||c=='q'||c=='R'||c=='r'||c=='S'||c=='s'||c=='T'||c=='t'||c=='U'||c=='u'||c=='V'||c=='v'||c=='W'||c=='w'||c=='X'||c=='x'||c=='Y'||c=='y'||c=='Z'||c=='z')
                return 1;
        else
                return 0;
}

int edge_compare (const void *vertex, const void *vertex2)
{
   if ((*((struct Edge **) vertex)) -> alignscore
         < (*((struct Edge **) vertex2)) -> alignscore)
      return 1;
   if ((*((struct Edge **) vertex)) -> alignscore
         > (*((struct Edge **) vertex2)) -> alignscore)
      return -1;
   return 0;
}
void makeset(int v,int dad[],int rank[])
{
	dad[v]=-1;
	rank[v]=0;
}
void Union(int v1, int v2, int dad[], int rank[])
{
	if(rank[v1]<rank[v2])
		dad[v1]=v2;
	else if(rank[v1]>rank[v2])
		dad[v2]=v1;
	else if(rank[v1]==rank[v2])
	{
		dad[v1]=v2;
		rank[v2]=rank[v2]+1;
	}
}
int find(int v, int dad[])
{
	if(dad[v]==-1)
		return v;
	int f=dad[v];
	int r=find(f,dad);
	dad[v]=r;
	return r;
}	
	
void  max_span(struct Edge* edge[],int n,struct Edge tree[])
{
	int* dad;
	dad=(int*)malloc(n*sizeof(int));
	int* rank;
	rank=(int*)malloc(n*sizeof(int));
	int count=0;
	int v;
	for(v=0;v<n;v++)
		makeset(v,dad,rank);
	int i;
	for(i=0;i<n*(n-1)/2;i++)
	{
		int r1=find(edge[i]->index1,dad);
		int r2=find(edge[i]->index2,dad);
		
		if(r1!=r2)
		{
			Union(r1,r2,dad,rank);
			tree[count].alignscore=edge[i]->alignscore;
			tree[count].index1=edge[i]->index1;
			tree[count].index2=edge[i]->index2;
			count++;
		}
		if(count==(n-1))
			break;
	}
	free(dad);
	free(rank);
}
